#!/bin/bash

# created by WIBOON 2556-04-13
# updated by WIBOON 2557-06-24

sudo apt-get -y install vsftpd
sudo groupadd ftpadmin
PREVUSER=$(grep "1000:.*/home" /etc/passwd | cut -d: -f1)
sudo gpasswd -a ${PREVUSER} ftpadmin
#check apache2 version
if [ -f "/etc/apache2/sites-available/default" ] ; then
  MYFILE="/etc/apache2/sites-available/default"
else
  if [ -f "/etc/apache2/sites-available/000-default.conf" ] ; then
    MYFILE="/etc/apache2/sites-available/000-default.conf"
  else
    echo "No apache2 default site config file"
    exit
  fi
fi
documentroot=$(grep DocumentRoot ${MYFILE} | cut -d' ' -f2)
sudo mkdir -p ${documentroot}/pub  
#
sudo mkdir -p /srv/ftp/pub  
sudo chgrp -R ftpadmin /srv/ftp/pub
sudo chmod -R g+rws,o+rx /srv/ftp/pub
sudo mkdir -p /sftp/ftp/pub
sudo chgrp -R ftpadmin /sftp/ftp/pub
sudo chmod -R g+rws,o+rx /sftp/ftp/pub
MYINSTALL="mount -R /srv"
MYFILE="/etc/rc.local"
if [ -z "$(grep "${MYINSTALL}" ${MYFILE})" ] ; then
  sudo mount -R /srv/ftp/pub  /sftp/ftp/pub
  sudo mount -R /srv/ftp/pub  ${documentroot}/pub
  sudo sed   -i "/^exit/i\mount -R /srv/ftp/pub /sftp/ftp/pub" ${MYFILE} 
  sudo sed   -i "/^exit/i\mount -R /srv/ftp/pub ${documentroot}/pub" ${MYFILE} 
fi
MYINSTALL="#PSU-netdrive-2557-06-24"
MYFILE="/etc/vsftpd.conf"
if [ -z "$(grep "${MYINSTALL}" ${MYFILE})" ] ; then
  echo "${MYINSTALL}" | sudo tee -a ${MYFILE}
  (echo 'anonymous_enable=YES
local_enable=YES
user_sub_token=$USER
local_root=/sftp/home/$USER
chroot_local_user=YES
chroot_list_enable=YES
chroot_list_file=/etc/vsftpd.chroot_list') | sudo tee -a ${MYFILE}
  echo "${PREVUSER}" | sudo tee /etc/vsftpd.chroot_list
fi
sudo service vsftpd restart
